/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the DocumentIdAutoIncTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DocumentIdAutoIncTrait{}

// DocumentIdAutoIncTrait struct for DocumentIdAutoIncTrait
type DocumentIdAutoIncTrait struct {
	Id NullableInt32 `json:"id,omitempty"`
}

// NewDocumentIdAutoIncTrait instantiates a new DocumentIdAutoIncTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDocumentIdAutoIncTrait() *DocumentIdAutoIncTrait {
	this := DocumentIdAutoIncTrait{}
	return &this
}

// NewDocumentIdAutoIncTraitWithDefaults instantiates a new DocumentIdAutoIncTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDocumentIdAutoIncTraitWithDefaults() *DocumentIdAutoIncTrait {
	this := DocumentIdAutoIncTrait{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *DocumentIdAutoIncTrait) GetId() int32 {
	if o == nil || IsNil(o.Id.Get()) {
		var ret int32
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *DocumentIdAutoIncTrait) GetIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *DocumentIdAutoIncTrait) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableInt32 and assigns it to the Id field.
func (o *DocumentIdAutoIncTrait) SetId(v int32) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *DocumentIdAutoIncTrait) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *DocumentIdAutoIncTrait) UnsetId() {
	o.Id.Unset()
}

func (o DocumentIdAutoIncTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DocumentIdAutoIncTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	return toSerialize, nil
}

type NullableDocumentIdAutoIncTrait struct {
	value *DocumentIdAutoIncTrait
	isSet bool
}

func (v NullableDocumentIdAutoIncTrait) Get() *DocumentIdAutoIncTrait {
	return v.value
}

func (v *NullableDocumentIdAutoIncTrait) Set(val *DocumentIdAutoIncTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableDocumentIdAutoIncTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableDocumentIdAutoIncTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDocumentIdAutoIncTrait(val *DocumentIdAutoIncTrait) *NullableDocumentIdAutoIncTrait {
	return &NullableDocumentIdAutoIncTrait{value: val, isSet: true}
}

func (v NullableDocumentIdAutoIncTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDocumentIdAutoIncTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
